#include "Crossover.h"

//============================================
//	class nPointCrossover
//============================================

nPointCrossover::nPointCrossover()
{
	crossoverRate = Parameter::getInstance().getCrossOverRate();
	numCrossover = Parameter::getInstance().getCrossOverNum();
	geneLength = Parameter::getInstance().getGeneLength();
	randomGenerator = &RandomGenerator::getInstance();
	createCrossoverTable();
}

//θĤ
void nPointCrossover::createCrossoverTable()
{
	crossoverTable.resize(0);
	for(int i=1;i<geneLength;i++){
		crossoverTable.push_back(i);
	}
}

//aȸb򺵤
void nPointCrossover::crossover(Individual& a,Individual& b) {
	//򺵤˿ƤФƤ
	a.setParent(a);
	b.setParent(b);
	
	if(randomGenerator->randomDouble() < crossoverRate) {
		vector<int> crossoverPoint;	//
		getCrossoverPoint(a,b,crossoverPoint);//Ĥ
		crossoverOnePair(a,b,crossoverPoint);//abcrossoverPointǸ򺵤
	}
	
}
//parent1parent2θꤹ
void nPointCrossover::getCrossoverPoint(Individual& parent1, Individual& parent2,vector<int>& crossoverPoint) {
	crossoverPoint.resize(0);
	//θ򥷥åե
	random_shuffle(crossoverTable.begin(),crossoverTable.end(),*randomGenerator);
	int numP=0;
	for(int i = 0; i < numCrossover; i++) {
		//θΰ֤Τparent1parent2ǰۤʤʤȤƺѤ
		if((parent1.getGene()[crossoverTable[numP]]^parent2.getGene()[crossoverTable[numP]])==1){
			crossoverPoint.push_back(crossoverTable[numP]);
		}
		else i--;
		numP++;
		if(numP==geneLength-1){
			for(int y=i+1;y<numCrossover;y++){
				crossoverPoint.push_back(crossoverTable[y]);
			}
			break;
		}
	}
	//򾺽¤ؤ
	sort(crossoverPoint.begin(),crossoverPoint.end());
}

//parent1parent2crossoverPointȤƸ򺵤
void nPointCrossover::crossoverOnePair(Individual& parent1, Individual& parent2, vector<int> crossoverPoint) {
	int* parent1Gene = parent1.getGene();
	int* parent2Gene = parent2.getGene();
	int* child1Gene = new int[geneLength];
	for(int i=0;i<geneLength;i++){
		child1Gene[i] = parent1Gene[i];
	}
	int* child2Gene = new int[geneLength];
	for(int i=0;i<geneLength;i++){
		child2Gene[i] = parent2Gene[i];
	}

	for(int i = 0; i < numCrossover; i++) {
		for(int j = crossoverPoint[i]; j < geneLength; j++) {
			if((i % 2) == 0) {
				child1Gene[j] = parent2Gene[j];
				child2Gene[j] = parent1Gene[j];
			}
			else {
				child1Gene[j] = parent1Gene[j];
				child2Gene[j] = parent2Gene[j];
			}
		}
	}
	parent1.setGene(child1Gene);
	parent2.setGene(child2Gene);
	delete [] child1Gene;
	delete [] child2Gene;
}

//Crossover饹Υ󥹥󥹤֤
Crossover& nPointCrossover::getInstance(){
	static Crossover* crossover;
	if(crossover == 0){
		crossover = new nPointCrossover;
	}
	return *crossover;
}

