#include "Evaluation.h"

//============================================
//	class Evaluation
//============================================
Evaluation::Evaluation(Parameter& para)
{
	designLength = para.getDesignLength();
	numDesign = para.getDesignNum();
	function = para.getfunc();
	coder = &GrayCoder::getInstance();
}


void Evaluation::evaluateOne(Individual& indiv){
    evaluateDesignValOne(indiv);

	double* objec = new double[function->getobjectiveNum()];
	function->evaluate(indiv.getdesignValue(),objec);

	indiv.setobjective(objec);
	delete [] objec;
	double* cons = new double[function->getconstraintNum()];
	function->evaluateConstraint(indiv.getdesignValue(),cons);

	indiv.setconstraint(cons);
	
	
	//¹ԲǽǤ뤫ɤ
	indiv.setisFeasible(true);
	int i=0;
	while(i < function->getconstraintNum()){
		if(cons[i]>0){
			indiv.setisFeasible(false);
			break;
		}
		i++;
	}
	delete [] cons;
}

    
void Evaluation::evaluateDesignValOne(Individual& indiv){
	int max_int = (1<<designLength);
	int* gene = indiv.getGene();
	int* tmp_gene = new int[designLength];
	int* variable = new int[numDesign];
	double* design = new double[numDesign];
	
	for(int i=0;i<numDesign;i++){
		for(int j=designLength*i;j<designLength*(i+1);j++){
			tmp_gene[j-i*designLength]=gene[j];
		}
		variable[i]=coder->graydecode(tmp_gene,designLength);
	}		
	
	for(int i=0;i<numDesign;i++){
		double tmp = (double) variable[i]/max_int;
		design[i]=function->getMin(i)+tmp*(function->getMax(i)-function->getMin(i));
	}
	indiv.setdesignValue(design);
	delete [] tmp_gene;
	delete [] variable;
	delete [] design;		
}

Evaluation& Evaluation::getInstance(){
	static Evaluation* eva;
	if(eva == 0){
		eva = new Evaluation(Parameter::getInstance());
	}
	return *eva;
}

