#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
using namespace std;

#include "Parameter.h"
#include "GAInitializer.h"
#include "Individual.h"
#include "Archive.h"
#include "Population.h"
#include "GrayCoder.h"
#include "OutputUnit.h"

int main(){
	clock_t start,end;
	start = clock();
	Parameter para = Parameter::getInstance();
	Archive archive(para);
	Population population;

	for(int i=1;i<=para.getMaxGeneration();i++){
		cout << "generation" << i << endl;
		
		population = archive.getSearchPopulation();
				
		population.evolve(i);
		
		archive.updateArchive(population);
		OutputUnit out;
		out.outputObjArchive(archive.getobjArchive(),i);
		out.outputVarArchive(archive.getvarArchive(),i);
	}
	end = clock();
	cout << (double) (end-start)/CLOCKS_PER_SEC << endl;

}

